static void
get_columnnames( List* candidates )
{
	int proc;
	int ret;
	StringInfoData	query;	/* string for Query */
	StringInfoData	cols;	/* string for Columns */
	Oid				advise_oid;
	ListCell		*cell;
	int b=0;
	
	SPITupleTable *SPI_tuptable;
	IndexCandidate* idxcd;
	/*TupleDesc tupdesc;*/
	HeapTuple tuple;
	/*SPITupleTable *tuptable;*/
	

	elog( DEBUG3, "IND ADV: get_column_names: ENTER" );

	

	
	initStringInfo( &query );
	initStringInfo( &cols );
	
	foreach( cell, candidates ) /* foreach cell in candidates */
	{
	
	
		idxcd = (IndexCandidate*)lfirst( cell );
	
		int i;
	

		/* pfree() the memory allocated for the previous candidate. FIXME: Avoid
		 * meddling with the internals of a StringInfo, and try to use an API.
		 */
		if( cols.len > 0 )
		{
			pfree( cols.data );
			cols.data = NULL;
		} /*IF col.len>0*/

	
		appendStringInfo( &query, "select a.attname from pg_class c,pg_attribute a where c.oid=%d AND a.attrelid = c.oid AND ", idxcd->reloid);
		
		for (i = 0; i < idxcd->ncols; ++i)
		{
		
			appendStringInfo( &cols, "a.attnum=%s%d", (i>0?"AND":""), idxcd->varattno[i]);

		
		}/* foreach col in varattno*/
		
		
		/* FIXME: Mention the column names explicitly after the table name. */
		appendStringInfo( &query, "%s;", cols.data);
		
		elog(INFO,"QUERY:%s", query.data);
		elog(INFO,"LONGITUD:%d", query.len);
		
	}	/* foreach cell in candidates */
		
		if( query.len > 0 )	/* if we generated any SQL */
		{
		
			if( SPI_connect() == SPI_OK_CONNECT )
			{
				
			    ret=SPI_exec(query.data, 0);
			    proc=SPI_processed;
				if( ret>0 )
				{
					
					b=1;
					elog(INFO,"b:%d", query.len);
					
					if( SPI_tuptable != NULL)
				    {
					
						SPITupleTable *tuptable = SPI_tuptable;
						TupleDesc tupdesc = tuptable->tupdesc;
						char buf[8192];
						int i,j;
						for(j=0;j<proc;j++)
						{
							
							/*cada fila*/
							tuple=tuptable->vals[j];
							for (i=0,buf[0]=0;i<tupdesc->natts;i++)
							{
						    	/* cada columna de cada fila*/
								char *data;
								data=SPI_getvalue(tuple,tupdesc,i);
								idxcd->varattnombres[i]=data;
						
							} /* (i=0,buf[0]=0;i<tupdesc->natts;i++)*/
						}/* (j=0;j<proc;j++)*/
					}/*if( SPI_tuptable != NULL)*/
					else
						elog( WARNING, "IND ADV: SPI_tuptable is null." );
			    }
			    else    
			    	  elog( WARNING, "IND ADV: SPI_execute failed while select." );
			    if( SPI_finish() != SPI_OK_FINISH )
				elog( WARNING, "IND ADV: SPI_finish failed while select." );
				
			} /*if( SPI_connect() == SPI_OK_CONNECT )*/			

			else
			elog( WARNING, "IND ADV: SPI_connect failed while select." );
	
	
					
	} /*if( query.len > 0 )*/
	
	/* TODO: Propose to -hackers to introduce API to free a StringInfoData . */
	if ( query.len > 0 )
		pfree( query.data );

	elog( DEBUG3, "IND ADV: select: EXIT" );
}


